<?php

/**
 * CI_NOVEDAD_AUSENTISMO actions.
 *
 * @package    nomina
 * @subpackage CI_NOVEDAD_AUSENTISMO
 * @author     Manuel Enrique Paredes Lopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class ci_novedad_ausentismoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CI_NOVEDAD_AUSENTISMO_V',
        'NO_DATOS_FUNCIONARIO_V',
        'TIPO_AUSENTISMO',
        'INTERCEROS_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_DATOS_FUNCIONARIO_V, LEFT' =>
        array(
            'num_doc' => 'CI_NOVEDAD_AUSENTISMO_V'
        ),
        'TIPO_AUSENTISMO, LEFT' =>
        array(
            'id_tipo_ausentismo-id' => 'CI_NOVEDAD_AUSENTISMO_V'
        ),
        'INTERCEROS_V, LEFT' =>
        array(
            'id_jefe-id_mae_ter' => 'CI_NOVEDAD_AUSENTISMO_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CI_NOVEDAD_AUSENTISMO_V' =>
        array(
            'id' => 'id',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'id_tipo_ausentismo' => 'id_tipo_ausentismo',
            'fecha_inicio' => 'fecha_inicio',
            'fecha_final' => 'fecha_final',
            'hora_inicio' => 'hora_inicio',
            'hora_final' => 'hora_final',
            'hora_inicio_sel' => 'hora_inicio_sel', //hora para el formato HH:MM - 20210426::LAVILA            
            'hora_final_sel' => 'hora_final_sel', //hora para el formato HH:MM - 20210426::LAVILA            
            'id_jefe' => 'id_jefe',
            'id_estado' => 'id_estado',
            'motivo_ausentismo' => 'motivo_ausentismo',
            'adjunto' => 'adjunto'
        ),
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'tipo_documento' => 'tipo_documento',
            'primer_nombre' => 'primer_nombre',
            'segundo_nombre' => 'segundo_nombre',
            'primer_apellido' => 'primer_apellido',
            'segundo_apellido' => 'segundo_apellido',
            'nombre_completo' => 'nombre_completo',
            'nombre_apellido' => 'nombre_apellido',
            'fecha_nace' => 'fecha_nace',
            'email' => 'email',
            'tel' => 'telefono',
            'direccion' => 'direccion',
            'pais_nace' => 'pais_nace',
            'depto_nace' => 'depto_nace',
            'muni_nace' => 'muni_nace',
            'genero' => 'genero',
            'tipo_sangre' => 'tipo_sangre',
            'estado_civil' => 'estado_civil',
        ),
        'TIPO_AUSENTISMO' =>
        array(
            'nombre' => 'nombre'
        ),
        'INTERCEROS_V' =>
        array(
            'num_doc' => 'num_doc_jefe',
            'id_tipo_doc' => 'id_tipo_doc_jefe',
            'razon_soc' => 'razon_soc_jefe'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id'
    ); //campos para el ordenamiento de la consulta


    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CI_NOVEDAD_AUSENTISMO_V' =>
        array(
            'id,a' => array('!=' => array(-1)),
            'id,b' => array('=' => array('id')),
            'id_tipo_ausentismo' => array('=' => array('id_tipo_ausentismo')),
            'num_doc' => array('LIKEALLPLUS' => array('num_doc')),
            'id_tipo_doc' => array('=' => array('id_tipo_doc')),
            'id_jefe' => array('=' => array('id_jefe')),
            'id_estado' => array('IN' => array('id_estado')),
            'fecha_inicio' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    protected $query_qualifier = 'DISTINCT'; //Para eliminar filas repetidas

    /*
     * Variable manejo de log
     */
    //si es servicio para filtro agregar campo
    protected $filtro = 'Novedad Ausentismo';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id'; //identificador de la tabla
    protected $id_names = array('id'); //llave primaria
    protected $field_names = array('id', 'id_tipo_doc', 'num_doc', 'id_tipo_ausentismo'
        , 'fecha_inicio', 'fecha_final', 'hora_inicio', 'hora_final', 'id_jefe', 'id_estado'
        , 'motivo_ausentismo', 'adjunto'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CI_NOVEDAD_AUSENTISMO'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {


        //valor por defecto
        $errors = null;



        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $id_filtro = $list_data_post[0]['id'];

            $this->envioNotificacion($request, $id_filtro);
        }

        //accion update
        if ($Action == "UPDATE") {
            $id_filtro = $list_data_post[0]['id'];
            $id_estado = $list_data_post[0]['id_estado'];
            if (isset($request['bandera_mail']) && $request['bandera_mail'] == 1) {
                $this->envioNotificacion($request, $id_filtro);
            }
            if ($id_estado == 2) {
                $this->envioNotificacionAprob($request, $id_filtro);
            }
            if ($id_estado == 3) {
                $this->envioNotificacionRechazar($request, $id_filtro);
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Correo de notificacion Al Agregar - 20210423
     * 
     * @param type $request
     * @param type $id_filtro
     */
    public function envioNotificacion($request, $id_filtro) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a envioNotificacion");

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        $correoEnvio = "";
        $service_url = "";
        $ruta = getcwd() . "/uploads/novedad_ausentismo";
        foreach ($array as $routeName => $routeData) {
            if ('service_url_local' == $routeName) {
                foreach ($routeData as $key => $value) {
                    if ($key == 'value') {
                        $service_url = $value;
                    }
                }
            }
            if ('correoEnvio' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $correoEnvio = $value;
                    }
                }
            }
            $int++;
        }

        /**
         * Envio de correo de error - 20190911
         */
        $logger->info("Envio de correo inicio ");

        //URL de servicio correo
        $url = $service_url . "curl_envio_correo/list.json";

        $comando = $request['comando'];
        $id_username = $request['id_username'];
        $username = $request['username'];

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CI_NOVEDAD_AUSENTISMO');

        //Sql
        $sql = <<<EOD
select 
                
usu.username,
'$comando' as comando,               
nov.id as id_tabla,
'$id_mae_bd' as id_mae_bd,
'$id_username' as id_username,
 case when nov.adjunto is null then 'false' else 'true' end as adjunto,
'$ruta' as ruta,    
nov.adjunto as nombre_reporte,
nov.id_estado as id_estado,
nov.motivo_ausentismo as motivo_ausentismo,
to_char(nov.fecha_inicio,'yyyy-mm-dd') as fecha_inicio,
to_char(nov.fecha_final,'yyyy-mm-dd') as fecha_final,
nov.id_tipo_doc,
nov.num_doc,
nov.id_tipo_ausentismo,
'gestiondeltalentohumano@anm.gov.co' as correo,
'$correoEnvio' as email_envio,
'' as mensaje_extra,
'' as mensaje_firma,
'El presente correo es para informar que se registro la novedad de Ausentismo del funcionario: '|| usu.nombre || ' ' || usu.apellido   as mensaje,
'Novedad de ausentismo: ' ||tip.nombre as subject,                        
                
--datos de envio
jefe.num_doc as num_doc_env,
jefe.id_tipo_doc as id_tipo_doc_env,
jefe.razon_soc as razon_social_env,
jefe.mail as correo_env,

--datos de envio usuario
usu.num_doc as num_doc_usu,
usu.id_tipo_doc as id_tipo_doc_usu,
usu.nombre || ' ' || usu.apellido as razon_social_usu,
usu.email as correo_usu

from CI_NOVEDAD_AUSENTISMO nov

left join tipo_ausentismo tip
on nov.id_tipo_ausentismo = tip.id

left join no_datos_funcionario_v func
on nov.num_doc = func.num_doc and nov.id_tipo_doc=func.id_tipo_doc

left join interceros_du_dir_v jefe
on jefe.id_mae_ter=nov.id_jefe


left join usuario usu
on usu.username = '$username'

where 1=1 and
nov.id = $id_filtro 
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        $this->logMessage("Envio correo");

        if (count($records) > 0) {

            $record = $records[0];

            foreach ($record as $key => $value) {
                $params[$key] = $value;
            }

            if ($service_url != null) {
                CN_TABLE::curlPostAsync($url, $params);
            }
        }

        $logger->info("Envio de correo fin");
    }

    /**
     * Correo de notificacion Al Aprob - 20210423
     * 
     * @param type $request
     * @param type $id_filtro
     */
    public function envioNotificacionAprob($request, $id_filtro) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a envioNotificacion");

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        $correoEnvio = "";
        $service_url = "";
        $ruta = getcwd() . "/uploads/novedad_ausentismo";
        foreach ($array as $routeName => $routeData) {
            if ('service_url_local' == $routeName) {
                foreach ($routeData as $key => $value) {
                    if ($key == 'value') {
                        $service_url = $value;
                    }
                }
            }
            if ('correoEnvio' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $correoEnvio = $value;
                    }
                }
            }
            $int++;
        }

        /**
         * Envio de correo de error - 20190911
         */
        $logger->info("Envio de correo inicio ");

        //URL de servicio correo
        $url = $service_url . "curl_envio_correo/list.json";

        $comando = $request['comando'];
        $id_username = $request['id_username'];
        $username = $request['username'];

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CI_NOVEDAD_AUSENTISMO');

        //Sql
        $sql = <<<EOD
select 
                
usu.username,
'$comando' as comando,               
nov.id as id_tabla,
'$id_mae_bd' as id_mae_bd,
'$id_username' as id_username,
 case when nov.adjunto is null then 'false' else 'true' end as adjunto,
'$ruta' as ruta,    
nov.adjunto as nombre_reporte,
nov.id_estado as id_estado,
nov.motivo_ausentismo as motivo_ausentismo,
to_char(nov.fecha_inicio,'yyyy-mm-dd') as fecha_inicio,
to_char(nov.fecha_final,'yyyy-mm-dd') as fecha_final,
nov.id_tipo_doc,
nov.num_doc,
nov.id_tipo_ausentismo,
'gestiondeltalentohumano@anm.gov.co' as correo,
'$correoEnvio' as email_envio,
'' as mensaje_extra,
'' as mensaje_firma,
'El presente correo es para informar que se aprobó la novedad de Ausentismo del funcionario '|| usu.nombre || ' ' || usu.apellido || '. Verificar en el modulo '  as mensaje,
'Aprobacion Novedad de ausentismo: ' ||tip.nombre as subject,                        
                
--datos de envio
jefe.num_doc as num_doc_env,
jefe.id_tipo_doc as id_tipo_doc_env,
jefe.razon_soc as razon_social_env,
jefe.mail as correo_env,

--datos de envio usuario
usu.num_doc as num_doc_usu,
usu.id_tipo_doc as id_tipo_doc_usu,
usu.nombre || ' ' || usu.apellido as razon_social_usu,
usu.email as correo_usu

from CI_NOVEDAD_AUSENTISMO nov

left join tipo_ausentismo tip
on nov.id_tipo_ausentismo = tip.id

left join no_datos_funcionario_v func
on nov.num_doc = func.num_doc and nov.id_tipo_doc=func.id_tipo_doc

left join interceros_du_dir_v jefe
on jefe.id_mae_ter=nov.id_jefe


left join usuario usu
on usu.username = '$username'

where 1=1 and
nov.id = $id_filtro 
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        $this->logMessage("Envio correo");

        if (count($records) > 0) {

            $record = $records[0];

            foreach ($record as $key => $value) {
                $params[$key] = $value;
            }

            if ($service_url != null) {
                CN_TABLE::curlPostAsync($url, $params);
            }
        }

        $logger->info("Envio de correo fin");
    }

    /**
     * Correo de notificacion Al Rechazar - 20210423
     * 
     * @param type $request
     * @param type $id_filtro
     */
    public function envioNotificacionRechazar($request, $id_filtro) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a envioNotificacion");

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        $correoEnvio = "";
        $service_url = "";
        $ruta = getcwd() . "/uploads/novedad_ausentismo";
        foreach ($array as $routeName => $routeData) {
            if ('service_url_local' == $routeName) {
                foreach ($routeData as $key => $value) {
                    if ($key == 'value') {
                        $service_url = $value;
                    }
                }
            }
            if ('correoEnvio' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $correoEnvio = $value;
                    }
                }
            }
            $int++;
        }

        /**
         * Envio de correo de error - 20190911
         */
        $logger->info("Envio de correo inicio ");

        //URL de servicio correo
        $url = $service_url . "curl_envio_correo/list.json";

        $comando = $request['comando'];
        $id_username = $request['id_username'];
        $username = $request['username'];

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CI_NOVEDAD_AUSENTISMO');

        //Sql
        $sql = <<<EOD
select 
                
usu.username,
'$comando' as comando,               
nov.id as id_tabla,
'$id_mae_bd' as id_mae_bd,
'$id_username' as id_username,
 case when nov.adjunto is null then 'false' else 'true' end as adjunto,
'$ruta' as ruta,    
nov.adjunto as nombre_reporte,
nov.id_estado as id_estado,
nov.motivo_ausentismo as motivo_ausentismo,
to_char(nov.fecha_inicio,'yyyy-mm-dd') as fecha_inicio,
to_char(nov.fecha_final,'yyyy-mm-dd') as fecha_final,
nov.id_tipo_doc,
nov.num_doc,
nov.id_tipo_ausentismo,
'gestiondeltalentohumano@anm.gov.co' as correo,
'$correoEnvio' as email_envio,
'' as mensaje_extra,
'' as mensaje_firma,
'El presente correo es para informar que se rechazo la novedad de Ausentismo del funcionario '|| usu.nombre || ' ' || usu.apellido || '. Verificar en el modulo. '  as mensaje,
'Rechazo Novedad de ausentismo: ' ||tip.nombre as subject,                       
                
--datos de envio
jefe.num_doc as num_doc_env,
jefe.id_tipo_doc as id_tipo_doc_env,
jefe.razon_soc as razon_social_env,
jefe.mail as correo_env,

--datos de envio usuario
usu.num_doc as num_doc_usu,
usu.id_tipo_doc as id_tipo_doc_usu,
usu.nombre || ' ' || usu.apellido as razon_social_usu,
usu.email as correo_usu

from CI_NOVEDAD_AUSENTISMO nov

left join tipo_ausentismo tip
on nov.id_tipo_ausentismo = tip.id

left join no_datos_funcionario_v func
on nov.num_doc = func.num_doc and nov.id_tipo_doc=func.id_tipo_doc

left join interceros_du_dir_v jefe
on jefe.id_mae_ter=nov.id_jefe


left join usuario usu
on usu.username = '$username'

where 1=1 and
nov.id = $id_filtro 
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        $this->logMessage("Envio correo");

        if (count($records) > 0) {

            $record = $records[0];

            foreach ($record as $key => $value) {
                $params[$key] = $value;
            }

            if ($service_url != null) {
                CN_TABLE::curlPostAsync($url, $params);
            }
        }

        $logger->info("Envio de correo fin");
    }

}
